/*  gngeo a neogeo emulator
 *  Copyright (C) 2001 Peponas Mathieu
 * 
 *  This program is free software; you can redistribute it and/or modify  
 *  it under the terms of the GNU General Public License as published by   
 *  the Free Software Foundation; either version 2 of the License, or    
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "SDL.h"
#include <stdio.h>
#include <stdlib.h>

#include "driver.h"

static DRIVER *driver_list=NULL;

static SDL_bool goto_next_driver(FILE * f)
{
    char buf[512];
    char game[10], type[5];
    long pos;

    while (!feof(f)) {
	pos=ftell(f);
	fgets(buf, 510, f);
	if (sscanf(buf, "game %10s %5s\n", game, type) >= 2) {
	    fseek(f,pos,SEEK_SET);
	    return SDL_TRUE;
	}
    }
    return SDL_FALSE;
}

static int get_sec_by_name(char *section) {
    static char *sec[SEC_MAX]={"CPU","SFIX","SM1","SOUND1","SOUND2","GFX"};
    int i;
    for(i=0;i<SEC_MAX;i++) {
	if (strcmp(sec[i],section)==0)
	    return i;
    }
    printf("Unknow section %s\n",section);
    return -1;
}

static void add_driver(FILE *f)
{
    DRIVER *dr;
    dr=malloc(sizeof(DRIVER));
}

/* load the specified file, and create the driver struct */
SDL_bool dr_load_driver(char *filename) {
    FILE *f;
    f=fopen(filename,"r");
    if (!f) return SDL_FALSE;
    while(goto_next_driver(f)==SDL_TRUE) {
	add_driver(f);
    }
    return SDL_TRUE;
}

void dr_list_all(void);
void dr_list_available(void);
DRIVER *dr_get_by_name(char *name);
SDL_bool dr_load_game(DRIVER *dr);
