
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <SDL/SDL.h>
#include "../screen.h"
#include "../video.h"

#include "scale2x.h"
#include "scale3x.h"

static Uint16 *dst0, *dst1, *dst2, *src0, *src1, *src2;
Uint16 height;
static SDL_Surface *scale4xtmp;

SDL_bool effect_scale2x_init(void)
{
	return SDL_TRUE;
}
SDL_bool effect_scale3x_init(void)
{
	return SDL_TRUE;
}
SDL_bool effect_scale4x_init(void)
{
    scale4xtmp=SDL_CreateRGBSurface(SDL_SWSURFACE,304*2, 224*2+16, 16,
				    0xF800, 0x7E0, 0x1F, 0);
    return SDL_TRUE;
}
static inline void internal_scale2x_16_def(Uint16* dst0, Uint16* dst1, const Uint16* src0, 
					   const Uint16* src1, const Uint16* src2, unsigned count) 
{
    /* we don't need to care about of this special case since our src bitmap is larger than
       the dest */
#if 0
	/* first pixel */
    dst0[0] = src1[0];
    dst1[0] = src1[0];
    if (src1[1] == src0[0] && src2[0] != src0[0])
        dst0[1] =src0[0];
    else
        dst0[1] =src1[0];
    if (src1[1] == src2[0] && src0[0] != src2[0])
        dst1[1] =src2[0];
    else
        dst1[1] =src1[0];
    ++src0;
    ++src1;
    ++src2;
    dst0 += 2;
    dst1 += 2;

	/* central pixels */
    count -= 2;
#endif
    while (count) 
	{
            if (src1[-1] == src0[0] && src2[0] != src0[0] && src1[1] != src0[0])
                dst0[0] = src0[0];
            else
                dst0[0] = src1[0];
            if (src1[1] == src0[0] && src2[0] != src0[0] && src1[-1] != src0[0])
                dst0[1] =src0[0];
            else
                dst0[1] =src1[0];

            if (src1[-1] == src2[0] && src0[0] != src2[0] && src1[1] != src2[0])
                dst1[0] =src2[0];
            else
                dst1[0] =src1[0];
            if (src1[1] == src2[0] && src0[0] != src2[0] && src1[-1] != src2[0])
                dst1[1] =src2[0];
            else
                dst1[1] =src1[0];

            ++src0;
            ++src1;
            ++src2;
            dst0 += 2;
            dst1 += 2;
            --count;
	}
#if 0
	/* last pixel */
    if (src1[-1] == src0[0] && src2[0] != src0[0])
        dst0[0] =src0[0];
    else
        dst0[0] =src1[0];
    if (src1[-1] == src2[0] && src0[0] != src2[0])
        dst1[0] =src2[0];
    else
        dst1[0] =src1[0];
    dst0[1] =src1[0];
    dst1[1] =src1[0];
#endif
}

/* scanline 50% variant of scale2x */
static inline void internal_scale2x_16_def_50(Uint16* dst0, Uint16* dst1, const Uint16* src0, 
					      const Uint16* src1, const Uint16* src2, unsigned count) 
{
#if 0
	/* first pixel */
	dst0[0] = src1[0];
	dst1[0] = src1[0];
	if (src1[1] == src0[0] && src2[0] != src0[0])
		dst0[1] =src0[0];
	else
		dst0[1] =src1[0];
	if (src1[1] == src2[0] && src0[0] != src2[0])
		dst1[1] =src2[0];
	else
		dst1[1] =src1[0];
	++src0;
	++src1;
	++src2;
	dst0 += 2;
	dst1 += 2;

	/* central pixels */
	count -= 2;
#endif
	while (count) 
	{
		if (src1[-1] == src0[0] && src2[0] != src0[0] && src1[1] != src0[0])
			dst0[0] = src0[0];
		else
			dst0[0] = src1[0];
		if (src1[1] == src0[0] && src2[0] != src0[0] && src1[-1] != src0[0])
			dst0[1] =src0[0];
		else
			dst0[1] =src1[0];

		if (src1[-1] == src2[0] && src0[0] != src2[0] && src1[1] != src2[0]) 
			dst1[0] =(src2[0]&0xf7de)>>1;
		else 
		  dst1[0] =(src1[0]&0xf7de)>>1;
		
		if (src1[1] == src2[0] && src0[0] != src2[0] && src1[-1] != src2[0])
			dst1[1] =(src2[0]&0xf7de)>>1;
		else
			dst1[1] =(src1[0]&0xf7de)>>1;
		

		++src0;
		++src1;
		++src2;
		dst0 += 2;
		dst1 += 2;
		--count;
	}
#if 0
	/* last pixel */
	if (src1[-1] == src0[0] && src2[0] != src0[0])
		dst0[0] =src0[0];
	else
		dst0[0] =src1[0];
	if (src1[-1] == src2[0] && src0[0] != src2[0])
		dst1[0] =src2[0];
	else
		dst1[0] =src1[0];
	dst0[1] =src1[0];
	dst1[1] =src1[0];
#endif
}

/* scanline 75% variant of scale2x */
static inline void internal_scale2x_16_def_75(Uint16* dst0, Uint16* dst1, const Uint16* src0, 
					      const Uint16* src1, const Uint16* src2, unsigned count) 
{
#if 0
	/* first pixel */
	dst0[0] = src1[0];
	dst1[0] = src1[0];
	if (src1[1] == src0[0] && src2[0] != src0[0])
		dst0[1] =src0[0];
	else
		dst0[1] =src1[0];
	if (src1[1] == src2[0] && src0[0] != src2[0])
		dst1[1] =src2[0];
	else
		dst1[1] =src1[0];
	++src0;
	++src1;
	++src2;
	dst0 += 2;
	dst1 += 2;

	/* central pixels */
	count -= 2;
#endif
	while (count) 
	{
		if (src1[-1] == src0[0] && src2[0] != src0[0] && src1[1] != src0[0])
			dst0[0] = src0[0];
		else
			dst0[0] = src1[0];
		if (src1[1] == src0[0] && src2[0] != src0[0] && src1[-1] != src0[0])
			dst0[1] =src0[0];
		else
			dst0[1] =src1[0];

		if (src1[-1] == src2[0] && src0[0] != src2[0] && src1[1] != src2[0]) {
			dst1[0] =(src2[0]&0xf7de)>>1;
			dst1[0] =((src2[0]&0xf7de)>>1)+((dst1[0]&0xf7de)>>1);
		} else {
		  dst1[0] =(src1[0]&0xf7de)>>1;
		  dst1[0] =((src1[0]&0xf7de)>>1)+((dst1[0]&0xf7de)>>1);
		}
		if (src1[1] == src2[0] && src0[0] != src2[0] && src1[-1] != src2[0]) {
			dst1[1] =(src2[0]&0xf7de)>>1;
			dst1[1] =((src2[0]&0xf7de)>>1)+((dst1[1]&0xf7de)>>1);
		} else {
			dst1[1] =(src1[0]&0xf7de)>>1;
			dst1[1] =((src1[0]&0xf7de)>>1)+((dst1[1]&0xf7de)>>1);
		}

		++src0;
		++src1;
		++src2;
		dst0 += 2;
		dst1 += 2;
		--count;
	}
#if 0
	/* last pixel */
	if (src1[-1] == src0[0] && src2[0] != src0[0])
		dst0[0] =src0[0];
	else
		dst0[0] =src1[0];
	if (src1[-1] == src2[0] && src0[0] != src2[0])
		dst1[0] =src2[0];
	else
		dst1[0] =src1[0];
	dst0[1] =src1[0];
	dst1[1] =src1[0];
#endif
}

void effect_scale2x_update()
{
    height = 224;
	
    dst0 = (Uint16 *)screen->pixels;
    dst1 = (Uint16 *)dst0 + 608;
    
    src1 = (Uint16 *)buffer->pixels + 336 * 16 + 16;
    src0 = (Uint16 *)src1 - 336;   
    src2 = (Uint16 *)src1 + 336;
    while(height--)
    {
#ifdef I386_ASM
	scale2x_16_mmx(dst0, dst1, src0, src1, src2, 304);
#else
	scale2x_16_def(dst0, dst1, src0, src1, src2, 304);
#endif
	
	dst0 += 608*2;
	dst1 += 608*2;
	
	src0 += 336;
	src1 += 336;
	src2 += 336;	
    }
}

void effect_scale4x_update()
{
    height = 224;
	
    dst0 = (Uint16 *)scale4xtmp->pixels;
    dst1 = (Uint16 *)dst0 + 608;
    
    src1 = (Uint16 *)buffer->pixels + 336 * 16 + 16;
    src0 = (Uint16 *)src1 - 336;   
    src2 = (Uint16 *)src1 + 336;
    while(height--)
    {
#ifdef I386_ASM
	scale2x_16_mmx(dst0, dst1, src0, src1, src2, 304);
#else
	scale2x_16_def(dst0, dst1, src0, src1, src2, 304);
#endif
	
	dst0 += 608*2;
	dst1 += 608*2;
	
	src0 += 336;
	src1 += 336;
	src2 += 336;	
    }

    height = 224*2;
    dst0 = (Uint16 *)screen->pixels;
    dst1 = (Uint16 *)dst0 + 1216;
    
    src1 = (Uint16 *)scale4xtmp->pixels + 608;
    src0 = (Uint16 *)src1 - 608;   
    src2 = (Uint16 *)src1 + 608;
    while(height--)
    {
#ifdef I386_ASM
	scale2x_16_mmx(dst0, dst1, src0, src1, src2, 304*2);
#else
	scale2x_16_def(dst0, dst1, src0, src1, src2, 304*2);
#endif
	
	dst0 += 608*4;
	dst1 += 608*4;
	
	src0 += 608;
	src1 += 608;
	src2 += 608;	
    }
}



void effect_scale3x_update()
{
    height = 224;
	
    dst0 = (Uint16 *)screen->pixels;
    dst1 = (Uint16 *)dst0 + 912;
    dst2 = (Uint16 *)dst1 + 912;

    src1 = (Uint16 *)buffer->pixels + 336 * 16 + 16;
    src0 = (Uint16 *)src1 - 336;   
    src2 = (Uint16 *)src1 + 336;
    while(height--)
    {

	scale3x_16_def(dst0, dst1, dst2, src0, src1, src2, 304);
	
	dst0 += (912<<1)+912;
	dst1 += (912<<1)+912;
	dst2 += (912<<1)+912;

	src0 += 336;
	src1 += 336;
	src2 += 336;	
    }
}

void
old_effect_scale2x_update()
{
	height = 224;
	
	dst0 = (Uint16 *)screen->pixels;
	dst1 = (Uint16 *)dst0 + 608;
	
	src1 = (Uint16 *)buffer->pixels + 336 * 16 + 16;
	src0 = (Uint16 *)src1 - 336;   
	src2 = (Uint16 *)src1 + 336;
	
	while(height--)
	{
	  internal_scale2x_16_def(dst0, dst1, src0, src1, src2, 304);
		
		dst0 += 608*2;
		dst1 += 608*2;
		
		src0 += 336;
		src1 += 336;
		src2 += 336;		
	}
}

void
effect_scale2x50_update()
{
	height = 224;
	
	dst0 = (Uint16 *)screen->pixels;
	dst1 = (Uint16 *)dst0 + 608;
	
	src1 = (Uint16 *)buffer->pixels + 336 * 16 + 16;
	src0 = (Uint16 *)src1 - 336;   
	src2 = (Uint16 *)src1 + 336;
	
	while(height--)
	{
	  internal_scale2x_16_def_50(dst0, dst1, src0, src1, src2, 304);
		
		dst0 += 608*2;
		dst1 += 608*2;
		
		src0 += 336;
		src1 += 336;
		src2 += 336;		
	}
}

void
effect_scale2x75_update()
{
	height = 224;
	
	dst0 = (Uint16 *)screen->pixels;
	dst1 = (Uint16 *)dst0 + 608;
	
	src1 = (Uint16 *)buffer->pixels + 336 * 16 + 16;
	src0 = (Uint16 *)src1 - 336;   
	src2 = (Uint16 *)src1 + 336;
	
	while(height--)
	{
	  internal_scale2x_16_def_75(dst0, dst1, src0, src1, src2, 304);
		
		dst0 += 608*2;
		dst1 += 608*2;
		
		src0 += 336;
		src1 += 336;
		src2 += 336;		
	}
}
